<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Scheduler: scheduler.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Scheduler
   &#160;<span id="projectnumber">1.0.0</span>
   </div>
   <div id="projectbrief">Cooperative Scheduler to run tasks</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">scheduler.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="scheduler_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/****************************************************************************</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (C) 2019 by FST Lisboa                                         *</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *                                                                          *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * This file is part of Scheduler.                                          *</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *                                                                          *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *   Scheduler is a cooperative scheduler that organizes and executes tasks *</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *   in defined period (ms).                                                *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *                                                                          *</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *   Scheduler is distributed in hope that it will be useful in executing   *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *   functions with certain periods.                                        *</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> ****************************************************************************/</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#ifndef __SCHEDULER_H__</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#define __SCHEDULER_H__</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;stdio.h&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="scheduler_8h.html#ad70c1074aa802db8cf4a326a7330a6d5">   39</a></span>&#160;<span class="preprocessor">#define TASKS_N 16  </span></div><div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="struct__tasks__t.html">   47</a></span>&#160;<span class="preprocessor">typedef struct _tasks_t{</span></div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="struct__tasks__t.html#a258408d6d5d13a24bfa5211d81ce1682">   48</a></span>&#160;    uint16_t <a class="code" href="struct__tasks__t.html#a258408d6d5d13a24bfa5211d81ce1682">period</a>;    </div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="struct__tasks__t.html#ac98d5d20f5aab3ef51e0ff5e30d16925">   49</a></span>&#160;    void (*func)();     </div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;}<a class="code" href="scheduler_8h.html#acddd0515fc69ad0c3cdb405f4cb9465a">tasks_t</a>;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keywordtype">void</span> <a class="code" href="scheduler_8h.html#a592c67d3184c2d78a8935bb296fdfd4e">scheduler_init</a>(<a class="code" href="struct__tasks__t.html">tasks_t</a> *init_tasks, uint16_t size);</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="keywordtype">void</span> <a class="code" href="scheduler_8h.html#a17d06ef7d87528a418e956cb189f3a78">scheduler</a>(uint32_t time_ms);</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;uint16_t <a class="code" href="scheduler_8h.html#ac768864df04249e064cb092a0669715d">scheduler_get_size</a>();</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="struct__tasks__t_html_a258408d6d5d13a24bfa5211d81ce1682"><div class="ttname"><a href="struct__tasks__t.html#a258408d6d5d13a24bfa5211d81ce1682">_tasks_t::period</a></div><div class="ttdeci">uint16_t period</div><div class="ttdef"><b>Definition:</b> scheduler.h:48</div></div>
<div class="ttc" id="scheduler_8h_html_ac768864df04249e064cb092a0669715d"><div class="ttname"><a href="scheduler_8h.html#ac768864df04249e064cb092a0669715d">scheduler_get_size</a></div><div class="ttdeci">uint16_t scheduler_get_size()</div><div class="ttdoc">Description of scheduler_get_size()</div><div class="ttdef"><b>Definition:</b> scheduler.c:32</div></div>
<div class="ttc" id="scheduler_8h_html_a17d06ef7d87528a418e956cb189f3a78"><div class="ttname"><a href="scheduler_8h.html#a17d06ef7d87528a418e956cb189f3a78">scheduler</a></div><div class="ttdeci">void scheduler(uint32_t time_ms)</div><div class="ttdoc">Description of scheduler()</div><div class="ttdef"><b>Definition:</b> scheduler.c:14</div></div>
<div class="ttc" id="scheduler_8h_html_a592c67d3184c2d78a8935bb296fdfd4e"><div class="ttname"><a href="scheduler_8h.html#a592c67d3184c2d78a8935bb296fdfd4e">scheduler_init</a></div><div class="ttdeci">void scheduler_init(tasks_t *init_tasks, uint16_t size)</div><div class="ttdoc">Description of scheduler_init()</div><div class="ttdef"><b>Definition:</b> scheduler.c:7</div></div>
<div class="ttc" id="struct__tasks__t_html"><div class="ttname"><a href="struct__tasks__t.html">_tasks_t</a></div><div class="ttdoc">Structure w/ Tasks info.</div><div class="ttdef"><b>Definition:</b> scheduler.h:47</div></div>
<div class="ttc" id="scheduler_8h_html_acddd0515fc69ad0c3cdb405f4cb9465a"><div class="ttname"><a href="scheduler_8h.html#acddd0515fc69ad0c3cdb405f4cb9465a">tasks_t</a></div><div class="ttdeci">struct _tasks_t tasks_t</div><div class="ttdoc">Structure w/ Tasks info.</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
